<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed } from 'vue';
import { useI18n } from 'vue-i18n';
import { storeToRefs } from 'pinia';
import { paneTypes } from '@/enums/enums';
import { useMetaStore } from '@/stores/meta';
import { useFreeformStore } from '@/stores/freeform';
import { useScheduleStore } from '@/stores/schedule';
import { useTimelineStore } from '@/stores/timeline';

const { t } = useI18n();
const $t = t;

const props = defineProps<{
    type: string,
    isDisabled?: boolean
}>();

const meta = useMetaStore();
const { paneType } = storeToRefs(meta);
let store = null;

if (paneType.value === paneTypes.FREEFORM) {
    store = useFreeformStore();
} else if (paneType.value === paneTypes.SCHEDULE || paneType.value === paneTypes.STREAM) {
    store = useScheduleStore();
}
else if (paneType.value === paneTypes.TIMELINE) {
    store = useTimelineStore();
}

//@ts-ignore
const { editRight } = store;
//@ts-ignore
const { getLockState } = storeToRefs(store);

const getLockedType = computed(() => {
    if (getLockState && getLockState.value && getLockState.value[props.type] !== null && getLockState.value[props.type] !== undefined) {
        return getLockState.value[props.type];
    }
    else
        return true;
});

const lock = (value: boolean) => {
    if (!getIsDisabled.value) {
        editRight({ value: value, type: props.type });
    }
};

const getIsDisabled = computed(() => {
    return getLockState && getLockState.value && props.type !== 'all' && props.type !== "commentable" ? !getLockState.value['all'] : false;
});

</script>
<template>
    <div class="px-2 py-1 hover:bg-gray-100 rounded-md">
        <button :class="{ 'text-gray-400 pointer-events-none': getIsDisabled }" class="w-full text-left"
            @click="lock(false)" v-if="getLockedType">
            <i class="ri-lock-unlock-line ri-lg" :class="getIsDisabled ? 'text-grey-400' : 'text-green-600'"></i>
            <span class="ml-2">{{ $t("adminMenu.lockStates.types." + type) }}
                {{ $t("adminMenu.lockStates.states.lock") }}</span>
        </button>
        <button :class="{ 'text-gray-400 pointer-events-none': getIsDisabled }" class="hover:text-black w-full text-left"
            @click="lock(true)" v-else>
            <i class="ri-lock-line ri-lg" :class="getIsDisabled ? 'text-grey-400' : 'text-red-700'"></i>
            <span class="ml-2">{{ $t("adminMenu.lockStates.types." + type) }}
                {{ $t("adminMenu.lockStates.states.unlock") }}</span>
        </button>
    </div>
</template>